"""
Django settings for UserSystem project.

Generated by 'django-admin startproject' using Django 2.2.3.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""
# ===========
import os
import sentry_sdk
from sentry_sdk.integrations.django import DjangoIntegration
from pathlib import Path
from datetime import timedelta, datetime
from os.path import dirname, abspath, join
from dotenv import load_dotenv
from . import get_env_variable


env_path = Path('.') / '.env'
load_dotenv(dotenv_path=env_path)

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

BASE_DIR = dirname(dirname(dirname(abspath(__file__))))
BASE_DIR_LOG = join(dirname(BASE_DIR), 'logs')
SECRET_KEY = get_env_variable('SECRET_KEY')
DEBUG = False


# ==========

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False

ALLOWED_HOSTS = get_env_variable('ALLOWED_HOSTS')

# ============= SENTRY ======================= #
sentry_sdk.init(
    dsn=get_env_variable('SENTRY_DSN'),
    integrations=[DjangoIntegration()]
)
# ============= /SENTRY ====================== #

# Application definition

INSTALLED_APPS = [
    'suit',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'dal',
    'dal_select2',
    'rest_framework',
    'rest_framework_jwt',
    'rest_framework_swagger',
    'users',
    'webhosts',
    'qualification.apps.QualificationConfig',
    'simple_history',
    'dynamic_preferences',
    'dynamic_preferences.users.apps.UserPreferencesConfig',
    'import_export',
    'url_filter',
    'places',
    'models',
    'imagekit',
    'taggit',
    'backup',
    'webfact.apps.WebfactConfig',
    'enterprise.apps.EnterpriseConfig',
    'django_celery_beat',
    'corsheaders',
    'django_slack'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.cache.UpdateCacheMiddleware',#
    'corsheaders.middleware.CorsMiddleware', 
    'django.middleware.common.CommonMiddleware',
    'django.middleware.cache.FetchFromCacheMiddleware',#
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'config.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [join(BASE_DIR,'templates/')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'config.wsgi.application'

# ================ DATABASE ================== #
DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': get_env_variable('DB_NAME'),
        'USER': get_env_variable('DB_USER'),
        'PASSWORD': get_env_variable('DB_PASSWORD'),
        'HOST': get_env_variable('DB_HOST'),
        'PORT': get_env_variable('DB_PORT', 5432),
    }
}
# ================ /DATABASE ================= #

# Database
# https://docs.djangoproject.com/en/2.2/ref/settings/#databases


# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'es-cl'

TIME_ZONE = 'America/Santiago'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/


STATIC_URL = '/static/'
STATIC_ROOT = 'static'
STATICFILES_DIRS = [join(BASE_DIR,'staticfiles/')]

# ==================== DRF =================== #

REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.IsAuthenticated',#  IsAuthenticated
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
    ),
    #token
    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.PageNumberPagination',
    'PAGE_SIZE': 100,
    'JWT_EXPIRATION_DELTA': timedelta(hours=48),
    "JWT_ALLOW_REFRESH": True,

}

JWT_AUTH = {'JWT_RESPONSE_PAYLOAD_HANDLER': 'users.views.jwt_response_payload_handler'}
# ==================== /DRF ================== #

# ================== CELERY ================== #
INSTALLED_APPS += ['celery']
if USE_TZ:
    CELERY_TIMEZONE = TIME_ZONE

# CELERY_BROKER_URL = get_env_variable('CELERY_BROKER_URL')
# CELERY_RESULT_BACKEND = get_env_variable('CELERY_RESULT_BACKEND')
CELERY_ACCEPT_CONTENT = get_env_variable('CELERY_ACCEPT_CONTENT')
CELERY_RESULT_SERIALIZER = get_env_variable('CELERY_RESULT_SERIALIZER')
CELERY_TASK_SERIALIZER = get_env_variable('CELERY_TASK_SERIALIZER')
CELERYD_TASK_TIME_LIMIT = get_env_variable('CELERYD_TASK_TIME_LIMIT')
CELERYD_TASK_SOFT_TIME_LIMIT = get_env_variable('CELERYD_TASK_SOFT_TIME_LIMIT')

# ================== /CELERY ================= #

# ================== SWAGGER ================= #
SWAGGER_SETTINGS = {
    'SECURITY_DEFINITIONS': {
        'api_key': {
            'type': 'apiKey',
            'in': 'header',
            'name': 'Authorization'
        }
    },
    'USE_SESSION_AUTH': False
}
# ================= /SWAGGER ================= #

# ============== CORSHEADERS ================= #
CORS_ORIGIN_ALLOW_ALL = False

BANDAANCHA2 = r'^http://bandaancha.cl/*$'

DEMOGIGA = r'^http://demo-giga.devel7.cl/*$'
DEMOGIGA_SSL = r'^https://demo-giga.devel7.cl/*$'

CORS_ORIGIN_REGEX_WHITELIST  =  [ 
    BANDAANCHA2,
    DEMOGIGA,
    DEMOGIGA_SSL
]

CORS_ORIGIN_WHITELIST  =  [ 
    'http://127.0.0.1',
    'http://localhost',
    'https://bandaancha.cl',
    'https://iris.devel7.cl',
    'https://matrix.devel7.cl',
    'https://pomaire.devel7.cl',
    'https://aguila.devel7.cl',
    'https://sentinel.devel7.cl',
    'https://demo-iris.devel7.cl',
    'https://demo-matrix.devel7.cl',
    'https://demo-sentinel.devel7.cl',
    'https://pulso-dev.devel7.cl',
    'https://coloradmin.devel7.cl',
    'https://sentinel-coloradmin.devel7.cl',
    'https://optic.matrix2.cl',
    'https://sentinel7.cl',
    'https://iris7.cl',
    'http://gigainternet.cl',
    'https://gigainternet.cl',      
]

# ============= /CORSHEADERS ================= #

# ============== ADMIN SUIT ================== #
SUIT_CONFIG  =  { 
    # header 
    'ADMIN_NAME': 'Pulso | Multifiber', 
    'HEADER_DATE_FORMAT': 'l, j. F Y ', 
    #' HEADER_TIME_FORMAT ':' H: i ',

    # formularios 
    'SHOW_REQUIRED_ASTERISK': True, # predeterminado verdadero 
    'CONFIRM_UNSAVED_CHANGES': True, # predeterminado verdadero

    # menu 
    # 'SEARCH_URL': '/ admin / auth / user /', 
    # 'MENU_ICONS': { 
    # 'sites': 'icon-leaf', 
    # 'auth': 'icon-lock', 
    #}, 
    # ' MENU_OPEN_FIRST_CHILD ': True, # Predeterminado True 
    #' MENU_EXCLUDE ': (' auth.group ',), 
    # ' MENU ': ( 
    # ' sites ', 
    # {' app ':' auth ',' icon ':' icon- lock ',' models ': (' user ',' group ')}, 
    # {' label ':' Settings ',' icon ':' icon-cog ',' models ': (' auth.user ',' auth.group ')}, 
    # {' label ':' Support ',' icon ':' icon-question-sign ',' url ':' / support / '},
    # ),

    # misc 
    'LIST_PER_PAGE': 100 
}
# ============== /ADMIN SUIT ================= #

# ================== LOG ===================== #

LOGGING_ = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '%(levelname)-.3s %(asctime)s %(module)s %(name)s %(message)s \n\n'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
    },
    'handlers': {
        'file': {
            'level': 'INFO',
            'class': 'logging.FileHandler',
            'formatter': 'verbose',
            'filename': join(BASE_DIR_LOG,'debug_django.log'),
        },
        'mail_admins': {
            'level': 'ERROR',
            'class': 'django.utils.log.AdminEmailHandler',
        },
        'console':{
            'level':'DEBUG',
            'class':'logging.StreamHandler',
            'formatter': 'simple'
        },
    },
    'loggers': {
        'django.request': {
            'handlers': ['mail_admins', 'file','console'],
            'level': 'DEBUG',
            'propagate': False,
        },
        '': {
            'handlers': ['file','console'],
            'propagate': True,
        },
    },
}

# ================== /LOG ==================== #

# ================= CACHE ==================== #
# Cache time to live is 12 hours.
CACHE_TTL = 60 * 720

# CACHES = {
#     "default": {
#         "BACKEND": "django_redis.cache.RedisCache",
#         "LOCATION": "redis://127.0.0.1:6379/1",
#         'TIMEOUT': 90,
#         "OPTIONS": {
#             "CLIENT_CLASS": "django_redis.client.DefaultClient"
#         },
#     }
# }

# ================= /CACHE =================== #

# ======== SLACK CREDENTIALS ========== #

SLACK_CLIENT_ID = get_env_variable('SLACK_CLIENT_ID')
SLACK_CLIENT_SECRET = get_env_variable('SLACK_CLIENT_SECRET')
SLACK_TOKEN_INFO = get_env_variable('SLACK_TOKEN_INFO')
SLACK_OAUTH_TOKEN = get_env_variable('SLACK_OAUTH_TOKEN')
SLACK_BOT_TOKEN = get_env_variable('SLACK_BOT_TOKEN')